/*****************************************************
This program was produced by the
CodeWizardAVR V2.05.0 Professional
Automatic Program Generator
 Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : zvezda
Version : luchshaay
Date    : 12.12.2018
Author  : Serzh 
Company : 
Comments: 


Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

/*      Danko,   .
https://radiokot.ru/forum/viewtopic.php?f=57&t=21235   */

#include <mega8.h>

#include <delay.h>


unsigned char digit_out[5], //   (  0  4 a)
                   cur_dig; // .  () 
unsigned int f=400,    //  
             h=5,      //   
             z=1000;   // ms    

                    
static flash unsigned char digits[] = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
  





// ---------------- Timer 2 overflow interrupt service routine -----------------------------


interrupt [TIM2_OVF] void timer2_ovf_isr(void){

     PORTC&=0b00000000;                  //   ( - off)
 
     PORTD=~digits[digit_out[cur_dig]];
 
     PORTC |= (1<<cur_dig);            //    (  - on)
     
         cur_dig++; if (cur_dig >= 5) {
        cur_dig = 0; 

    } 
   
}// ----------------------------------------------------------------------------------------

// ----------------------------------------------------------------------------------------

void view_pauza(void) {
    digit_out[0] = 15;
    digit_out[1] = 15;
    digit_out[2] = 15;
    digit_out[3] = 15;
    digit_out[4] = 15;
       delay_ms(z);
       }
// ----------------------------------------------------------------------------------------

void view_flasher(void) {
     int i,j;
   for (j =0; j<h;++j){
   
   for (i =0; i<9;++i){
      
     unsigned int A[] = {8,5,2,5,8,5,2,5,8}; 
     unsigned int B[] = {8,5,2,5,8,5,2,5,8}; 
     unsigned int C[] = {8,5,2,5,8,5,2,5,8};
     unsigned int D[] = {8,5,2,5,8,5,2,5,8};
     unsigned int E[] = {8,5,2,5,8,5,2,5,8}; 
     
     
    digit_out[0] = A[i];
    digit_out[1] = B[i];
    digit_out[2] = C[i];
    digit_out[3] = D[i];
    digit_out[4] = E[i]; 
    
        delay_ms(f);
     } 
      
  }
  view_pauza();
}

// ----------------------------------------------------------------------------------------

void view_flasher_1(void) {
     int i,j;
   for (j =0; j<h;++j){
   
   for (i =0; i<9;++i){
      
     unsigned int A[] = {8,1,2,4,8,4,2,1,8}; 
     unsigned int B[] = {8,1,2,4,8,4,2,1,8}; 
     unsigned int C[] = {8,1,2,4,8,4,2,1,8}; 
     unsigned int D[] = {8,1,2,4,8,4,2,1,8}; 
     unsigned int E[] = {8,1,2,4,8,4,2,1,8}; 
     
     
    digit_out[0] = A[i];
    digit_out[1] = B[i];
    digit_out[2] = C[i];
    digit_out[3] = D[i];
    digit_out[4] = E[i]; 
    
        delay_ms(f);
    }   
     
 }  
     view_pauza();
   }
// ----------------------------------------------------------------------------------------
 
void view_flasher_2(void) {
     int i,j;
   for (j =0; j<h;++j){
   
   for (i =0; i<12;++i){
      
     unsigned int A[] = {15,15,15,15,15,0,0,0,0,0,15,0}; 
     unsigned int B[] = {0,15,15,15,15,15,0,0,0,0,15,0}; 
     unsigned int C[] = {0,0,15,15,15,15,15,0,0,0,15,0}; 
     unsigned int D[] = {0,0,0,15,15,15,15,15,0,0,15,0};
     unsigned int E[] = {0,0,0,0,15,15,15,15,15,0,15,0}; 
     
     
    digit_out[0] = A[i];
    digit_out[1] = B[i];
    digit_out[2] = C[i];
    digit_out[3] = D[i];
    digit_out[4] = E[i]; 
    
        delay_ms(f);
    } 
 }  
       view_pauza();
   }    
   
   // ----------------------------------------------------------------------------------------

void view_flasher_3(void) {
     int i,j;
   for (j =0; j<h;++j){
   
   for (i =0; i<23;++i){
      
     unsigned int A[] = {0,0,8,12,14,15,15,15,15,15 ,15,15,15,15,15,15,14,12, 8,0,0,15,0}; 
     unsigned int B[] = {2,7,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,7,2,15,0}; 
     unsigned int C[] = {0,0,0,1,3,7,15,15,15,15    ,15,15,15,15,15, 7 ,3 ,1 ,0,0,0,15,0};
     unsigned int D[] = {0,0,0,0,0,0,0,1,3,7        ,15,7,  3, 1 ,0 ,0 ,0 ,0 ,0,0,0,15,0};
     unsigned int E[] = {0,0,0,0,0,0,8,12,14,15     ,15,15,14,12 ,8 ,0 ,0 ,0 ,0,0,0,15,0}; 
     
     
    digit_out[0] = A[i];
    digit_out[1] = B[i];
    digit_out[2] = C[i];
    digit_out[3] = D[i];
    digit_out[4] = E[i]; 
    
        delay_ms(200);
    } 
      
  }
   view_pauza(); 
}

   // ----------------------------------------------------------------------------------------

void view_flasher_4(void) {
     int i,j;
   for (j =0; j<h;++j){
   
   for (i =0; i<5;++i){
      
     unsigned int A[] = {15, 8, 0,15, 8}; 
     unsigned int B[] = { 8,15, 8, 0,15}; 
     unsigned int C[] = {15, 8,15, 8, 0};
     unsigned int D[] = { 0,15, 8,15, 8};
     unsigned int E[] = { 8, 0,15, 8,15}; 
     
     
    digit_out[0] = A[i];
    digit_out[1] = B[i];
    digit_out[2] = C[i];
    digit_out[3] = D[i];
    digit_out[4] = E[i]; 
    
        delay_ms(f);
    }
       
  }
   view_pauza(); 
}


   // ----------------------------------------------------------------------------------------

void view_flasher_5(void) {
     int i,j;
   for (j =0; j<h;++j){
   
   for (i =0; i<18;++i){
      
     unsigned int A[] = {8,8,8,8,8,13,13,13,13,13,15,15,15,15,15,13,8,0}; 
     unsigned int B[] = {0,8,8,8,8, 8,13,13,13,13,13,15,15,15,15,13,8,0}; 
     unsigned int C[] = {0,0,8,8,8, 8, 8,13,13,13,13,13,15,15,15,13,8,0};
     unsigned int D[] = {0,0,0,8,8, 8, 8, 8,13,13,13,13,13,15,15,13,8,0};
     unsigned int E[] = {0,0,0,0,8, 8, 8, 8, 8,13,13,13,13,13,15,13,8,0}; 
     
     
    digit_out[0] = A[i];
    digit_out[1] = B[i];
    digit_out[2] = C[i];
    digit_out[3] = D[i];
    digit_out[4] = E[i]; 
    
        delay_ms(f);
    }  
      
  }
   view_pauza();
}


   // ----------------------------------------------------------------------------------------

void view_flasher_6(void) {
     int i,j;
   for (j =0; j<h;++j){
   
   for (i =0; i<10;++i){
      
     unsigned int A[] = {14,8,0,0,0,0,0,0,0,3}; 
     unsigned int B[] = {0,3,14,8,0,0,0,0,0,0}; 
     unsigned int C[] = {0,0,0,3,14,8,0,0,0,0};
     unsigned int D[] = {0,0,0,0,0,3,14,8,0,0};
     unsigned int E[] = {0,0,0,0,0,0,0,3,14,8}; 
     
     
    digit_out[0] = A[i];
    digit_out[1] = B[i];
    digit_out[2] = C[i];
    digit_out[3] = D[i];
    digit_out[4] = E[i]; 
    
        delay_ms(f);
    } 
       
  }
   view_pauza();
}

  // ----------------------------------------------------------------------------------------
void view_flasher_7(void) {
     int i,j;
   for (j =0; j<h;++j){
   
   for (i =0; i<40;++i){
      
     unsigned int A[] = {2,0,0,0,0,0,1,4,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,4,1,0,0,0,0,2}; 
     unsigned int B[] = {0,2,0,0,0,0,0,0,1,4,0,0,0,0,0,0,0,8,0,0,0,0,8,0,0,0,0,0,0,0,4,1,0,0,0,0,0,2,0}; 
     unsigned int C[] = {0,0,2,0,0,0,0,0,0,0,1,4,0,0,0,0,0,0,8,0,0,8,0,0,0,0,0,0,4,1,0,0,0,0,0,0,2,0,0};
     unsigned int D[] = {0,0,0,2,0,0,0,0,0,0,0,0,1,4,0,0,0,0,0,8,8,0,0,0,0,0,4,1,0,0,0,0,0,0,0,2,0,0,0};
     unsigned int E[] = {0,0,0,0,2,4,0,0,0,0,0,0,0,0,1,8,0,0,0,0,0,0,0,0,8,1,0,0,0,0,0,0,0,0,2,0,0,0,0}; 
     
     
    digit_out[0] = A[i];
    digit_out[1] = B[i];
    digit_out[2] = C[i];
    digit_out[3] = D[i];
    digit_out[4] = E[i]; 
    
        delay_ms(80);
    }
        
  }
   view_pauza();
}

  // ----------------------------------------------------------------------------------------

void view_flasher_8(void) {
     int i,j;
   for (j =0; j<h;++j){
   
   for (i =0; i<25;++i){
      
     unsigned int A[] = {0,8,8,14,15,0,0,0,0,0,0,0,0,8,8,8,8,8,8,8,8,8,14,15,15}; 
     unsigned int B[] = {14,15,15,15,15,0,0,0,0,8,12,14,15,15,15,15,15,15,15,15,15,15,15,15,15}; 
     unsigned int C[] = {8,8,14,15,15,0,0,0,8,8,8,8,8,8,8,8,8,8,8,12,14,15,15,15,15};
     unsigned int D[] = {3,3,11,11,15,0,2,3,3,3,3,3,3,3,3,3,3,3,11,11,11,11,11,11,15};
     unsigned int E[] = {0,14,15,15,15,0,0,0,0,0,0,0,0,0,8,12,14,15,15,15,15,15,15,15,15}; 
     
     
    digit_out[0] = A[i];
    digit_out[1] = B[i];
    digit_out[2] = C[i];
    digit_out[3] = D[i];
    digit_out[4] = E[i]; 
    
        delay_ms(f);
    } 
       
  }
   view_pauza();
}

  // ----------------------------------------------------------------------------------------

void view_flasher_9(void) {
     int i,j;
   for (j =0; j<h;++j){
   
   for (i =0; i<6;++i){
      
     unsigned int A[] = {8,5,2,8,5,2}; 
     unsigned int B[] = {8,5,2,8,5,2}; 
     unsigned int C[] = {8,5,2,8,5,2};
     unsigned int D[] = {8,5,2,8,5,2};
     unsigned int E[] = {8,5,2,8,5,2}; 
     
     
    digit_out[0] = A[i];
    digit_out[1] = B[i];
    digit_out[2] = C[i];
    digit_out[3] = D[i];
    digit_out[4] = E[i]; 
    
        delay_ms(f);
    } 
       
  }
   view_pauza();
}

  // ----------------------------------------------------------------------------------------

void view_flasher_10(void) {
     int i,j;
   for (j =0; j<h;++j){
   
   for (i =0; i<5;++i){
      
     unsigned int A[] = {0, 0,8,5,2}; 
     unsigned int B[] = {2, 5,8,0,0}; 
     unsigned int C[] = {0, 0,8,5,2};
     unsigned int D[] = {12,3,0,0,0};
     unsigned int E[] = {1, 6,8,0,0}; 
     
     
    digit_out[0] = A[i];
    digit_out[1] = B[i];
    digit_out[2] = C[i];
    digit_out[3] = D[i];
    digit_out[4] = E[i]; 
    
        delay_ms(f);
    } 
       
  }
   view_pauza();
}

  // ----------------------------------------------------------------------------------------

void view_flasher_11(void) {
     int i,j;
   for (j =0; j<h;++j){
   
   for (i =0; i<6;++i){
      
     unsigned int A[] = {0, 0,  0, 8,13,15}; 
     unsigned int B[] = {0, 2,  7,15,15,15}; 
     unsigned int C[] = {0, 0,  0, 8,13,15};
     unsigned int D[] = {0,12,15,15,15,15};
     unsigned int E[] = {0, 1,  7,15,15,15}; 
     
     
    digit_out[0] = A[i];
    digit_out[1] = B[i];
    digit_out[2] = C[i];
    digit_out[3] = D[i];
    digit_out[4] = E[i]; 
    
        delay_ms(f);
    } 
       
  }
   view_pauza();
}

  // ----------------------------------------------------------------------------------------

void view_flasher_12(void) {
     int i,j;
   for (j =0; j<h;++j){
   
   for (i =0; i<15;++i){
      
     unsigned int A[] = {15,15,15,15,13,15,15,15,15,10,15,15,15,15, 7}; 
     unsigned int B[] = {13,15,15,15,15,10,15,15,15,15, 7,15,15,15,15}; 
     unsigned int C[] = {15,13,15,15,15,15,10,15,15,15,15, 7,15,15,15};
     unsigned int D[] = {15,15,13,15,15,15,15,10,15,15,15,15, 7,15,15};
     unsigned int E[] = {15,15,15,13,15,15,15,15,10,15,15,15,15, 7,15}; 
     
     
    digit_out[0] = A[i];
    digit_out[1] = B[i];
    digit_out[2] = C[i];
    digit_out[3] = D[i];
    digit_out[4] = E[i]; 
    
        delay_ms(150);
    } 
       
  }
  
}

//===================================== main ==============================================
  
// 
void main(void){
          
   digit_out[0]=0;   //  
   digit_out[1]=0;
   digit_out[2]=0;
   digit_out[3]=0;
   digit_out[4]=0;
   
 
// 
PORTB=0b00000000; 
 DDRB=0b00000000; 
PORTC=0b00000000;   //  4    1
 DDRC=0b00011111;   //  4    
PORTD=0b00000000;  // D      0
 DDRD=0b00001111;  // D    

TCCR2=0x04;
TIMSK=0b01000000;
//              0b11000001
//                ||   | |
//                ||   | Timer0
//                ||   Timer1
//                |Timer2
//
#asm("sei")   //   
   
// --------------------------------   ------------------------------------------
 while (1) { 
  
     
  view_flasher(); 
  view_flasher_1(); 
  view_flasher_2();  
  view_flasher_3();
  view_flasher_4(); 
  view_flasher_5(); 
  view_flasher_6(); 
  view_flasher_7(); 
  view_flasher_8();
  view_flasher_9(); 
  view_flasher_10();  
  view_flasher_11(); 
  view_flasher_12();
  
 }; // -----------------------------   (end) ------------------------------------

} // =================================== end main ==========================================

//
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- The End -=-=-=-=-=--=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//









